"use strict";

const Promise = require("bluebird");
const pipe = require("@promistream/pipe");
const collect = require("@promistream/collect");
const rangeNumbers = require("@promistream/range-numbers");
const map = require("@promistream/map");
const parallelize = require("./");

return Promise.try(() => {
	return pipe([
		rangeNumbers(0, 20),
		map((value) => {
			let delay = Math.floor(Math.random() * 100);

			return Promise.delay(delay).then(() => value);
		}),
		parallelize(3),
		collect()
	]).read();
}).then((results) => {
	console.log(results);
});
